{% extends "customers/base.html" %}
{% load staticfiles %}
{% load widget_tweaks %}

{% block title %}Promociones{% endblock %}

{% block page %}
<!-- begin breadcrumb -->
<ol class="breadcrumb float-xl-right">
<li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
<li class="breadcrumb-item active">Promociones</li>
</ol>
<!-- end breadcrumb -->

<!-- begin page-header -->
<h1 class="page-header">Nueva <small>promoción</small></h1>
<!-- end page-header -->

<!-- begin row -->
<div class="row">
    <!-- begin col-12 -->
    <div class="col-xl-12 ui-sortable">
        <!-- begin panel -->
        <div class="panel panel-inverse" data-sortable-id="ui-general-1">
            <!-- begin panel-heading -->
            <div class="panel-heading ui-sortable-handle">
                <h4 class="panel-title">Nueva promoción</h4>
                <div class="panel-heading-btn">
                    <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
                    <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
                    <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
                    <a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
                </div>
            </div>
            <!-- end panel-heading -->
            <!-- begin panel-body -->
            <div class="panel-body">
                <form method="post" class='form-horizontal' id="form">
                    {% csrf_token %}
                    <div class="form-group m-b-15 col-sm-3" style='display: inline-block'>
                        <div class="row">
                            <div class="col-sm-8"> 
                                <label for="id_initial_date" class="col-sm-8 control-label m-b-15">Fecha inicio:</label>
                                <input id='id_initial_date' class="form-control m-b-5 datepicker" type='text' name='initial_date' required/>
                                </div>
                    </div>
                    </div>
                    <div class="form-group m-b-15 col-sm-3" style='display: inline-block;'>
                        <div class="row">
                        <div class="col-sm-8"> 
                        <label for="id_end_date" class="col-sm-8 control-label m-b-15">Fecha fin:</label>
                            <input id='id_end_date' class="form-control m-b-5 datepicker" type='text' name='end_date' />
                        </div>
                            <div class="col-sm-4"> 
                                <label for="id_permanent" class="col-sm-4 control-label m-b-15">Permanente:</label>
                                <input id='id_permanent' class="form-control" style="height: 10px;" type='checkbox' name='permanent' />
                            </div>
                        </div>
                    </div>
                   
                    <div class="form-group m-b-15 col-sm-5" style='display: inline-block; top:35px ;'>
                        <label for="id_name" class="col-sm-12 control-label m-b-15">Nombre de la promoción</label>
                        <div class="col-sm-12">
                            <input class="form-control m-b-5" type="text" name="name" maxlength="255" id="id_name"  required/>
                        </div>
                    </div>
                    <div class="form-group m-b-15 col-sm-6" style='display: inline-block'>
                        <label for="id_operator" class="col-sm-4 control-label m-b-15">Operador</label>
                        <div class="col-sm-12">
                            <select id="id_operator" name="operator" class="form-control">
                            {% for operator in operators %}
                                <option value="{{ operator.pk }}">{{ operator }}</option>
                            {% endfor %}
                            </select>
                        </div>
                    </div>
                    <div class="form-group m-b-15 col-sm-5" style='display: inline-block'>
                        <label for="id_description" class="col-sm-12 control-label m-b-15">Descripcion de la promoción</label>
                        <div class="col-sm-12">
                            <input class="form-control m-b-5" type="text" name="description" maxlength="300" id="id_description" required/>
                        </div>
                    </div>
                    <div class="form-group m-b-15 col-sm-6" style='display: inline-block'>
                        <label for="id_plan" class="col-sm-12 control-label m-b-15">Plan a aplicar</label>
                        <div class="col-sm-12">
                            <select name="plan" class="form-control m-b-5" id="id_plan"  multiple>
                                <option disabled selected value>Seleccionar plan</option>
                                {%for i in plans %}
                                <option value="{{i.pk}}">{{i.name}}</option>
                                {%endfor%}
                            </select> 
                        </div>
                    </div>
                    <div id='period-number-id' class="form-group m-b-15 col-sm-5" style='display: inline-block; position: relative; bottom: 70px;'>
                        <label for="id_number_periods" class="col-sm-12 control-label m-b-15">Cantidad de períodos</label>
                        <div class="col-sm-12">
                            <select class="form-control m-b-5" type="number" name="number_periods" id="id_number_periods" required>
                                <option value='1'>1</option>
                                <option value='2'>2</option>
                                <option value='3'>3</option>
                                <option value='4'>4</option>
                                <option value='5'>5</option>
                                <option value='6'>6</option>
                                <option value='7'>7</option>
                                <option value='8'>8</option>
                                <option value='9'>9</option>
                                <option value='10'>10</option>
                                <option value='11'>11</option>
                                <option value='12'>12</option>
                            </select>
                        </div>
                    </div>
                    <div id='dynamic-fields-container' class="form-group m-b-15 col-sm-11">
                        <div style='display:flex; align-items: center'>
                            <label class='col-sm-4 control-label m-b-15'>Descuento para período 1</label>
                            <div class='col-sm-8 m-b-15' style='display:flex'>
                                <select onchange='discountTypeCallback("tipo_descuento1")' id='tipo-descuento1' name='tipo_descuento1' class='form-control m-b-5' required>
                                    <option disabled selected value>Tipo de descuento</option>
                                    <option value='percent'>Porcentaje</option>
                                    <option value='amount'>Monto fijo</option>
                                </select>
                                <input id='valor_descuento1' style='margin-left: 10px'class="form-control m-b-5" type='number' min=0 name='valor_descuento1' placeholder='Monto del descuento' required/>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-11" style='padding-left:30px'>
                        <input type="submit" value="Crear" class="btn btn-primary">
                        <a href="{% url 'home' %}" class="btn btn-default">Cancelar</a>
                    </div>
                </form>
            <!-- end panel -->
            </div>
        </div>
    <!-- end column -->
    </div>
</div>
<!-- end row -->

<!-- begin scroll to top btn -->
<a href="javascript:;" class="btn btn-icon btn-circle btn-success btn-scroll-to-top fade" data-click="scroll-top"><i class="fa fa-angle-up"></i></a>
<!-- end scroll to top btn -->
{% endblock %}

{% block pageleveljs %}
<script type="text/javascript">
    //active menu
    document.getElementById("promotions_menu").classList.add("active");
    //active submenu item
    document.getElementById("promotions_list").classList.add("active");
</script>

<script>
    var dynamicFields = 1;
    var my_dict = JSON.parse("{{ my_dict|escapejs }}");

    $('#id_number_periods').change(function (e) {

        if (Number(e.target.value) > dynamicFields) {
            if($('#id_permanent').is(':checked'))
            {
                if (Number('1') < dynamicFields) {
                    var fieldsToDelete = dynamicFields - Number('1');
                    // alert(fieldsToDelete);
                    for (var i=0;i<fieldsToDelete;i++) {
                        $('#dynamic-fields-container').children().last().remove();
                    }
                    dynamicFields = Number('1')
                }
                document.querySelector("#id_number_periods").value = '1';
                form_count=$('#id_number_periods').val();
                // save the form_count to another input element (you can set this to invisible. This is what you will pass to the form in order to create the django form fields
                $("[name=number_periods]").val(form_count);
            }
            for (var i=dynamicFields;i<e.target.value;i++) {
                $('#dynamic-fields-container').append(
                    "<div style='display:flex; align-items: center'><label class='control-label col-sm-4 m-b-15'>Descuento para periodo "+(i+1)
                    +"</label><div class='col-sm-8 m-b-15' style='display:flex'><select id='tipo_descuento"+(i+1)+"' name='tipo_descuento"+(i+1)
                    +"' class='form-control m-b-5' required onchange='discountTypeCallback(&apos;tipo_descuento"+(i+1)+"&apos;)'>"
                    +"<option disabled selected value>Tipo de descuento</option><option value='percent'>Porcentaje</option><option "
                    +"value='amount'>Monto fijo</option></select><input required style='margin-left: 10px'class='form-control m-b-5' type='number' "
                    +"name='valor_descuento"+(i+1)+"' id='valor_descuento"+(i+1)+"'placeholder='Monto del descuento'/></div></div>"
                )
            }
            dynamicFields = Number(e.target.value);
        } else if (Number(e.target.value) < dynamicFields) {
            var fieldsToDelete = dynamicFields - e.target.value;
            for (var i=0;i<fieldsToDelete;i++) {
                $('#dynamic-fields-container').children().last().remove();
            }
            dynamicFields = Number(e.target.value)
        }
        form_count=$('#id_number_periods').val();
        // save the form_count to another input element (you can set this to invisible. This is what you will pass to the form in order to create the django form fields
        $("[name=number_periods]").val(form_count);
    })
    var discountTypeCallback = function(e) {
        var typeofDiscount=$('#'+e).val()
        var amountFieldId = e.replace('tipo', 'valor')
        if (typeofDiscount === 'percent') {
            $('#'+amountFieldId).attr('max', 100)
            $('#'+amountFieldId).attr('min', 1)
        } else {
            $('#'+amountFieldId).attr('min', 0)
        }
    }
    $('#id_operator').change(function(){
        var operator_id = $('#id_operator').val();
        $.get("/plans/ajax", {operator: operator_id}, function(data) {
            $('#id_plan').empty()
            $('#id_plan').append('<option disabled selected value>Seleccionar plan</option>')
            data.data.forEach(plan=>{
                $('#id_plan').append('<option value='+plan.pk+'>'+plan.name+'</option>')
            })
        });
    });
    $('#id_permanent').change(function(){
        if($('#id_permanent').is(':checked'))
            {
                //alert(dynamicFields);
                //e=$("#id_number_periods").val();
                if (Number('1') < dynamicFields) {
                    var fieldsToDelete = dynamicFields - Number('1');
                    // alert(fieldsToDelete);
                    for (var i=0;i<fieldsToDelete;i++) {
                        $('#dynamic-fields-container').children().last().remove();
                    }
                    dynamicFields = Number('1')
                }
                document.querySelector("#id_number_periods").value = '1';
                form_count=$('#id_number_periods').val();
                // save the form_count to another input element (you can set this to invisible. This is what you will pass to the form in order to create the django form fields
                $("[name=number_periods]").val(form_count);
            // checked document.getElementById("id_number_periods").setAttribute('value','1');
            }else
            {
            // unchecked
            }
    });
    $( "#id_initial_date" ).datepicker({
        showButtonPanel: true,
        minDate: my_dict, // minDate: '0' would work too
        beforeShowDay: noLastThreeDays,
        dateFormat: "dd/mm/yy"
    });
    $( "#id_end_date" ).datepicker({
        minDate: my_dict, // minDate: '0' would work too
        dateFormat: "dd/mm/yy"
    });

    function noLastThreeDays(date){
        //REM: Last day of month
        var tLastDayOfMonth = new Date(date.getFullYear(), date.getMonth() + 1, 0);
        
        //REM: Date of the passed date
        var tDate = date.getDate();
        if (my_dict=='0'){
            return [true, "", ""]
        }
        //REM: Lock the last three days of the month
        if(
            tDate === 20 ||
            tDate === 21 ||
            tDate === 22 ||
            tDate === 23 ||
            tDate === 24 ||
            tDate === 25 ||
            tDate === 26 ||
            tDate === 27 ||
            tDate === 28 ||
            tDate === 29 ||
            tDate === 30 ||
            tDate === 31
        ){
            return [false, "closed", "Sorry We are closed"]
        }
        else{
        return [true, "", ""]
        }
    }
 
</script>
{% endblock %}



